-
Notifications
You must be signed in to change notification settings - Fork 77
Commit
This commit does not belong to any branch on this repository, and may belong to a fork outside of the repository.
- Loading branch information
Showing
1 changed file
with
93 additions
and
0 deletions.
There are no files selected for viewing
This file contains bidirectional Unicode text that may be interpreted or compiled differently than what appears below. To review, open the file in an editor that reveals hidden Unicode characters.
Learn more about bidirectional Unicode characters
Original file line number | Diff line number | Diff line change |
---|---|---|
@@ -0,0 +1,93 @@ | ||
# 1105. Filling Bookcase Shelves | ||
|
||
- Difficulty: Medium. | ||
- Related Topics: Array, Dynamic Programming. | ||
- Similar Questions: . | ||
|
||
## Problem | ||
|
||
You are given an array `books` where `books[i] = [thicknessi, heighti]` indicates the thickness and height of the `ith` book. You are also given an integer `shelfWidth`. | ||
|
||
We want to place these books in order onto bookcase shelves that have a total width `shelfWidth`. | ||
|
||
We choose some of the books to place on this shelf such that the sum of their thickness is less than or equal to `shelfWidth`, then build another level of the shelf of the bookcase so that the total height of the bookcase has increased by the maximum height of the books we just put down. We repeat this process until there are no more books to place. | ||
|
||
Note that at each step of the above process, the order of the books we place is the same order as the given sequence of books. | ||
|
||
|
||
|
||
- For example, if we have an ordered list of `5` books, we might place the first and second book onto the first shelf, the third book on the second shelf, and the fourth and fifth book on the last shelf. | ||
|
||
|
||
Return **the minimum possible height that the total bookshelf can be after placing shelves in this manner**. | ||
|
||
|
||
Example 1: | ||
|
||
![](https://assets.leetcode.com/uploads/2019/06/24/shelves.png) | ||
|
||
``` | ||
Input: books = [[1,1],[2,3],[2,3],[1,1],[1,1],[1,1],[1,2]], shelfWidth = 4 | ||
Output: 6 | ||
Explanation: | ||
The sum of the heights of the 3 shelves is 1 + 3 + 2 = 6. | ||
Notice that book number 2 does not have to be on the first shelf. | ||
``` | ||
|
||
Example 2: | ||
|
||
``` | ||
Input: books = [[1,3],[2,4],[3,2]], shelfWidth = 6 | ||
Output: 4 | ||
``` | ||
|
||
|
||
**Constraints:** | ||
|
||
|
||
|
||
- `1 <= books.length <= 1000` | ||
|
||
- `1 <= thicknessi <= shelfWidth <= 1000` | ||
|
||
- `1 <= heighti <= 1000` | ||
|
||
|
||
|
||
## Solution | ||
|
||
```javascript | ||
/** | ||
* @param {number[][]} books | ||
* @param {number} shelfWidth | ||
* @return {number} | ||
*/ | ||
var minHeightShelves = function(books, shelfWidth) { | ||
var dp = Array(books.length).fill(0).map(() => Array(shelfWidth)); | ||
var helper = function(i, rowWidthLeft, rowHeight) { | ||
if (i === books.length) return rowHeight; | ||
if (dp[i][rowWidthLeft - 1]) return dp[i][rowWidthLeft - 1]; | ||
var res = Number.MAX_SAFE_INTEGER; | ||
// put current book on the same row | ||
if (books[i][0] <= rowWidthLeft) { | ||
res = Math.min(res, helper(i + 1, rowWidthLeft - books[i][0], Math.max(rowHeight, books[i][1]))); | ||
} | ||
// put current book on the next row | ||
res = Math.min(res, rowHeight + helper(i + 1, shelfWidth - books[i][0], books[i][1])); | ||
dp[i][rowWidthLeft - 1] = res; | ||
return res; | ||
}; | ||
return helper(0, shelfWidth, 0); | ||
}; | ||
|
||
|
||
``` | ||
|
||
**Explain:** | ||
|
||
nope. | ||
|
||
**Complexity:** | ||
|
||
* Time complexity : O(n * m). | ||
* Space complexity : O(n * m). |